<template>
  <div class="flex flex-col items-start pb-5 w-full relative">
    <p>{{ label }}</p>
    <div
      class="border-2 transition rounded p-2 w-full flex items-stretch gap-x-1"
      :class="
        error
          ? 'border-rose-400'
          : 'border-blue-300 focus-within:border-blue-600'
      "
    >
      <input
        v-if="!isTextarea"
        :type="actualType"
        :value="modelValue"
        @blur="blurInput"
        @input="update"
      />
      <textarea
        v-if="isTextarea"
        class="resize-none w-full bg-transparent"
        :value="modelValue"
        @blur="blurInput"
        @input="update"
      />
      <div v-if="isPassword" class="flex items-center justify-center">
        <div
          class="flex p-1 transition items-center justify-center rounded hover:bg-blue-100 cursor-pointer"
          @click="togglePasswordType"
        >
          <EyeSlash
            v-if="showPassword"
            class="w-5 h-5 fill-current text-blue-400"
          />
          <Eye
            v-if="!showPassword"
            class="w-5 h-5 fill-current text-blue-400"
          />
        </div>
      </div>
    </div>
    <transition name="from-bottom" mode="out-in">
      <span
        v-if="error"
        :key="error"
        class="absolute top-[calc(100%-22px)] text-sm text-red-600"
      >
        <span>{{ error }}</span>
      </span>
    </transition>
  </div>
</template>

<script setup lang="ts">
import Eye from "@/assets/icons/eye.svg?component";
import EyeSlash from "@/assets/icons/eye-slash.svg?component";

const props = defineProps({
  modelValue: {
    type: [String, Number],
    default: "",
  },
  label: {
    type: String,
    default: "label",
  },
  error: {
    type: String,
    default: "",
  },
  type: {
    type: String,
    default: "",
  },
  isTextarea: {
    type: Boolean,
    default: false,
  },
  isPassword: {
    type: Boolean,
    default: false,
  },
});
const $emit = defineEmits(["update:modelValue", "input", "blur"]);
const update = (e: Event) => {
  $emit("update:modelValue", (e.target as HTMLInputElement).value.trim());
  $emit("input", (e.target as HTMLInputElement).value.trim());
};

const blurInput = (e: Event) => {
  $emit("blur", (e.target as HTMLInputElement).value.trim());
};

const showPassword = ref(false);

const actualType = computed(() => {
  if (!props.isPassword) return "text";

  return showPassword.value ? "text" : "password";
});

const togglePasswordType = () => {
  showPassword.value = !showPassword.value
}
</script>
